import { MailFilled, PrinterFilled } from "@ant-design/icons";
import { Space, Spin } from "antd";
import { useState } from "react";
import { GenerateDocument } from "../../utils/RenderTemplate";
import { useNotification } from "../../contexts/Notifications/notificationContext.jsx";

export default function PrintWrapperComponent({
  templateObject,
  messageObject = {},
  children,
  id,
  emailOnly = false,
  disabled
}) {
  const [loading, setLoading] = useState(false);
  const notification = useNotification();

  const handlePrint = async (type) => {
    if (disabled) return;
    setLoading(true);
    await GenerateDocument(templateObject, messageObject, type, id, notification);
    setLoading(false);
  };

  return (
    <Space>
      {children || null}
      {!emailOnly && (
        <PrinterFilled
          disabled={disabled}
          onClick={() => handlePrint("p")}
          style={{ cursor: disabled ? "not-allowed" : null }}
        />
      )}
      <MailFilled
        disabled={disabled}
        onClick={() => handlePrint("e")}
        style={{ cursor: disabled ? "not-allowed" : null }}
      />
      {loading && <Spin />}
    </Space>
  );
}
